<?php
namespace Util;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DependencyInjection\InstanceManager;
use Util\Instance\Service as InstanceService;
use Util\Instance\Repository as InstanceRepository;
use Util\Instance\Factory as InstanceFactory;

class InstanceProvider {
    
    public static function getService()
    {
        return InstanceService::getInstance();
    }
    
    public static function getRepository()
    {
        return InstanceRepository::getInstance();
    }
    
    public static function getFactory()
    {
        return InstanceFactory::getInstance();
    }

    /** @return \Doctrine\ORM\EntityManager */
    public static function getEntityManager()
    {
        return InstanceManager::getInstance()->getService('entityManager');
    }
    /** @return \Teknisa\Libs\Controller\Api */
    public static function getLibsControllerApi()
    {
        return InstanceManager::getInstance()->getService('\Teknisa\Libs\Controller\Api');
    }
    /** @return \Zeedhi\Framework\Session\Session */
    public static function getSession()
    {
        return InstanceManager::getInstance()->getService('session');
    }
    /** @return  \Util\Mail\AttachmentMail */
    public static function getMailAttachmentMail()
    {
        return InstanceManager::getInstance()->getService('\Util\Mail\AttachmentMail');
    }

    /** @return \Teknisa\Libs\Util\Environment */
    public static function getLibEnvironment()
    {
        return InstanceManager::getInstance()->getService('libEnvironment');
    }

    /** @return \Teknisa\Libs\Util\Utilities */
    public static function getLibUtilities()
    {
        return InstanceManager::getInstance()->getService('libUtilities');
    }

    /** @return \Zeedhi\DevOps\Util\Environment */
    public static function getDevOpsEnvironment()
    {
        return InstanceManager::getInstance()->getService('environment');
    }

    /** @return \Zeedhi\Framework\Remote\FileUploader\Server */
    public static function getZhFileUpload()
    {
        return InstanceManager::getInstance()->getService('fileUploader');
    }
}