IF EXISTS (SELECT * FROM SYSOBJECTS O, sysusers U
           WHERE O.NAME = 'LOG_PED_ITEMPREBASE'         AND
                 TYPE = 'TR' 		                AND
	              U.UID = O.UID                     AND
	              U.NAME = USER)
                      
DROP TRIGGER LOG_PED_ITEMPREBASE
GO

CREATE TRIGGER LOG_PED_ITEMPREBASE
ON ITEMPREBASE
FOR INSERT,UPDATE,DELETE
AS
   DECLARE  @V_USUARIO   VARCHAR(40);
   DECLARE  @V_TIPO      VARCHAR(1);
   DECLARE  @V_ITPESQ    VARCHAR(40);
   DECLARE  @V_DESC      VARCHAR(300);
   DECLARE  @V_DTOPER    DATETIME;


  /*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE @V_ID_COMANDO           VARCHAR(1);
   DECLARE @V_CDPRODUTO_OLD        VARCHAR(21);
   DECLARE @V_CDPRECOBASE_OLD      VARCHAR(5);
   DECLARE @V_DTINIVALIPB_OLD      DATETIME;
   DECLARE @V_DTFIMVALIPB_OLD      DATETIME;
   DECLARE @V_VRITEPREBASE_OLD     DOUBLE PRECISION;
   

   DECLARE @V_CDPRODUTO_NEW        VARCHAR(21);
   DECLARE @V_CDPRECOBASE_NEW      VARCHAR(5);
   DECLARE @V_DTINIVALIPB_NEW      DATETIME;
   DECLARE @V_DTFIMVALIPB_NEW      DATETIME;
   DECLARE @V_VRITEPREBASE_NEW     DOUBLE PRECISION;

BEGIN

   SET @V_DESC     = '';
   SET @V_TIPO     = '0';

   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, ' ');

   DECLARE C_CURSOR CURSOR FOR

      SELECT
         'U' IDCOMANDO,
      DELETED.CDPRECOBASE,
      DELETED.CDPRODUTO,
      DELETED.DTINIVALIPB,
      DELETED.DTFIMVALIPB,
      DELETED.VRITEPREBASE,

      INSERTED.CDPRECOBASE,
      INSERTED.CDPRODUTO,
      INSERTED.DTINIVALIPB,
      INSERTED.DTFIMVALIPB,
      INSERTED.VRITEPREBASE

   FROM
      INSERTED,
      DELETED
   WHERE
       INSERTED.CDPRECOBASE     = DELETED.CDPRECOBASE

   UNION ALL

   SELECT
      'I' IDCOMANDO,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      
      INSERTED.CDPRECOBASE,
      INSERTED.CDPRODUTO,
      INSERTED.DTINIVALIPB,
      INSERTED.DTFIMVALIPB,
      INSERTED.VRITEPREBASE

   FROM
      INSERTED
   WHERE
       CDPRECOBASE      NOT IN (SELECT  CDPRECOBASE      FROM DELETED)

   UNION ALL

   SELECT
         'D' IDCOMANDO,
      DELETED.CDPRECOBASE,
      DELETED.CDPRODUTO,
      DELETED.DTINIVALIPB,
      DELETED.DTFIMVALIPB,
      DELETED.VRITEPREBASE,

      NULL,
      NULL,
      NULL,
      null,
      null

   FROM
      DELETED
   WHERE
       CDPRECOBASE      NOT IN (SELECT  CDPRECOBASE      FROM INSERTED)

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_CDPRECOBASE_OLD,
                                 @V_CDPRODUTO_OLD,
                                 @V_DTINIVALIPB_OLD,
                                 @V_DTFIMVALIPB_OLD,
                                 @V_VRITEPREBASE_OLD,

                                 @V_CDPRECOBASE_NEW,
                                 @V_CDPRODUTO_NEW,
                                 @V_DTINIVALIPB_NEW,
                                 @V_DTFIMVALIPB_NEW,
                                 @V_VRITEPREBASE_NEW
;

WHILE (@@FETCH_STATUS = 0) BEGIN

      IF NOT @V_USUARIO IS NULL BEGIN
         IF @V_ID_COMANDO= 'D' /*DELETING*/ BEGIN
            SET @V_TIPO = '3';
            IF @V_CDPRECOBASE_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Preo Base: ' + @V_CDPRECOBASE_OLD;
            END;
            IF @V_CDPRODUTO_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Produto: ' + @V_CDPRODUTO_OLD;
            END;
            IF @V_DTINIVALIPB_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Data Inicial: ' + @V_DTINIVALIPB_OLD;
            END;
            IF @V_DTFIMVALIPB_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Data Final: ' + @V_DTFIMVALIPB_OLD;
            END;
            IF @V_VRITEPREBASE_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Valor: ' + @V_VRITEPREBASE_OLD;
            END;

            SET @V_ITPESQ = @V_CDPRECOBASE_OLD;
        END
        ELSE BEGIN
       	  IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN

            IF (ISNULL(@V_DTINIVALIPB_NEW,'!')       <> ISNULL(@V_DTINIVALIPB_OLD,'!'))         OR
               (ISNULL(@V_DTFIMVALIPB_NEW,'!')       <> ISNULL(@V_DTFIMVALIPB_OLD,'!'))         OR
               (ISNULL(@V_VRITEPREBASE_NEW,'!')       <> ISNULL(@V_VRITEPREBASE_OLD,'!'))       BEGIN
                 
                 SET  @V_TIPO   = '2';
                 SET  @V_ITPESQ = @V_CDPRECOBASE_OLD;

              END;
           END
        	  ELSE BEGIN
           		SET @V_TIPO   = '1';
               SET  @V_ITPESQ = @V_CDPRECOBASE_NEW;
           END;
        END;
      END;

      IF (@V_ID_COMANDO= 'I') OR (@V_ID_COMANDO='U') BEGIN

            IF @V_CDPRECOBASE_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Preo Base: ' + @V_CDPRECOBASE_OLD;
            END;
            IF @V_CDPRODUTO_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Produto: ' + @V_CDPRODUTO_OLD;
            END;
            IF @V_DTINIVALIPB_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Data Inicial: ' + @V_DTINIVALIPB_OLD;
            END;
            IF @V_DTFIMVALIPB_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Data Final: ' + @V_DTFIMVALIPB_OLD;
            END;
            IF @V_VRITEPREBASE_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Valor: ' + @V_VRITEPREBASE_OLD;
            END;

      END;

      IF (@V_TIPO <> '0')  BEGIN
         IF NOT @V_DESC IS NULL BEGIN
            EXEC NMUSUARIO @V_USUARIO;
            SET  @V_DTOPER = GETDATE();
            INSERT INTO LOGOPERA
                     ( NMTABELA, DTOPERACAO, NMRESPOPER,
                        IDTIPOOPER, CDPESQITEM, DSOPERACAO)
               VALUES
                     ('PARAMFORNE', @V_DTOPER, @V_USUARIO,
                        @V_TIPO, @V_ITPESQ, @V_DESC);
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_CDPRECOBASE_OLD,
                                 @V_CDPRODUTO_OLD,
                                 @V_DTINIVALIPB_OLD,
                                 @V_DTFIMVALIPB_OLD,
                                 @V_VRITEPREBASE_OLD,

                                 @V_CDPRECOBASE_NEW,
                                 @V_CDPRODUTO_NEW,
                                 @V_DTINIVALIPB_NEW,
                                 @V_DTFIMVALIPB_NEW,
                                 @V_VRITEPREBASE_NEW;
   END;

   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_PED_ITEMPREBASE','5.50.000';
GO
