<?php

namespace Teknisa\Model\Geral\Repositories;


class Parcnegocio extends \Doctrine\ORM\EntityRepository {



    public function findBilletIssuedFct($nrlanctonf){
        $query = <<<SQL
            SELECT CDFILIAL, NRLANBOLREC,CDREDUCONT
          FROM (SELECT C.CDFILIAL,BO.NRLANBOLREC,BO.CDREDUCONT
                  FROM CONTARECEBER C
                  JOIN NOTAFISCAL N ON (N.NRLANCTONF = C.NRLANCTONF AND N.CDFILIAL = C.CDFILIAL AND N.NRORG = C.NRORG )
                  JOIN CLIENTE CLI ON (N.CDCLIENTE = CLI.CDCLIENTE AND N.NRORG = CLI.NRORG)
                  JOIN BOLETRECEBER BO ON (BO.NRLANBOLREC = C.NRLANBOLREC AND BO.CDFILIAL = C.CDFILIAL)
                  JOIN FCT_APURACAO APU ON APU.NRLANCTONF = N.NRLANCTONF AND APU.CDFILIAL = N.CDFILIAL
             WHERE APU.NRLANCTONF = :NRLANCTONF)

             GROUP BY CDFILIAL, NRLANBOLREC, CDREDUCONT

SQL;

        $params = array(
            "NRLANCTONF" => $nrlanctonf
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    /**
     * @param $filter
     * @param $dtinicompetFilter
     * @param $dtfincompetFilter
     * @param $nrorg
     * @param $nrparcnegocio
     * @return array
     */
    public function getFaturamentoContrato($filter, $dtinicompetFilter, $dtfincompetFilter, $dtinicompetFilterMed, $dtfincompetFilterMed, $nrorg, $nrparcnegocio, $limit = 500, $offset = 1, $orderString)
    {
        $query =
            <<<SQL
        SELECT *
            FROM (SELECT DISTINCT DECODE(AGRUPCONT.NRMEDICAOFATURA, NULL, 'P', DECODE(AGRUPCONT.IDPARCAGRUP, 'S', 'A', 'M')) AS TIPO, AGRUPCONT.IDPARCAGRUP, TO_CHAR(DSJUSTIFICATIVA) AS DSJUSTIFICATIVA,
                   DECODE(AGRUPCONT.IDPARCAGRUP, 'N', CONT.NRCONTRATOFCT,  AGRUPA.NMAGRUPAMENTO) AS NRCONTRATOFCT,
                   CASE AGRUPCONT.IDPARCAGRUP WHEN 'N'
                        THEN TO_CHAR(CONT.NRSEQCONTRATO)
                        ELSE (SELECT LISTAGG(NRSEQCONTRATO, '_') WITHIN GROUP( ORDER BY NRSEQCONTRATO)
                                FROM FCT_RELACAGRUPCONTFAT
                               WHERE NRFATURACONT = FAT.NRFATURACONT)
                    END AS NRSEQCONTRATO,
                   DECODE(AGRUPCONT.NRMEDICAOFATURA, NULL, 'P'||FAT.NRFATURACONT, DECODE(AGRUPCONT.IDPARCAGRUP, 'S', 'A'||FAT.NRFATURACONT, 'M'||AGRUPCONT.NRMEDICAOFATURA)) AS NRFATURACONT, FAT.NRGRUPOFATURA, FAT.CDFILIALFATURA, FILIFAT.NMFILIAL AS NMFILIALFATURA,
                   FAT.NRPARCFATURA, PARCFAT.NMPRINCIPALPARC AS NMPARCFATURA, FAT.IDTPFATURA,
                   CASE
                       WHEN CONTREC.IDSTATREC = 'B' THEN 'RECEBIDO'
                       WHEN NF.NRNOTAFISC IS NULL THEN 'PENDENTE'
                       WHEN TRUNC(CONTREC.DTATUAVENREC) < TRUNC(SYSDATE) THEN 'ATRASO'
                       ELSE 'FATURADA'
                   END AS IDSITUACAO,
                   FAT.DTINICOMPET, FAT.DTFINCOMPET,
                   FAT.DTLIMITEAPU, DECODE(NF.NRNOTAFISC, NULL, NULL, CONTREC.DTATUAVENREC) AS DTVENCIMENTO, FAT.NRDIASVENCIMENTO, FAT.QTDIASFATUVENC, FAT.VRVENCIMENTO,
                   FAT.VRFATURADO, FAT.VRFALTAFATURAR, FAT.IDFORMAFATURA, FAT.IDALTUSUARIO, FAT.NRAPURACAO, NF.NRLANCTONF,
                   NF.CDFILIAL AS CDFILIALNF, FILINF.NMFILIAL AS NMFILIALNF, NF.NRNOTAFISC, NF.DTENTRSAID, FAT.IDATIVO,
                   FAT.NRORG, FAT.DTINCLUSAO, FAT.NRORGINCLUSAO, FAT.CDOPERINCLUSAO, FAT.DTULTATU, FAT.NRORGULTATU,
                   FAT.CDOPERULTATU,
                   DECODE(AGRUPCONT.IDPARCAGRUP, 'S', AGRUPA.DSOBSAGRUPAMENTO, CONT.DSREFERENCIACONT) DSREFERENCIACONT,
                   NF.VRNOTAFISC,
                   DECODE(NF.NRNOTAFISC, NULL, NULL, CONTREC.VRATUAREC) AS VRATUAREC
              FROM FCT_FATURACONT FAT
        INNER JOIN FCT_RELACAGRUPCONTFAT AGRUPCONT
                ON FAT.NRFATURACONT = AGRUPCONT.NRFATURACONT
               AND FAT.NRORG        = AGRUPCONT.NRORG
         LEFT JOIN FCT_CONTRATO CONT
                ON AGRUPCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
               AND AGRUPCONT.NRORG         = CONT.NRORG
         LEFT JOIN FCT_RELACAGRUPAMENTOCONT RELAGRUPCONT
                ON RELAGRUPCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
               AND RELAGRUPCONT.NRORG         = CONT.NRORG
         LEFT JOIN FCT_AGRUPAMENTO AGRUPA
                ON AGRUPA.NRAGRUPAMENTO = RELAGRUPCONT.NRAGRUPAMENTO
               AND AGRUPA.NRORG         = RELAGRUPCONT.NRORG
        INNER JOIN FILIAL FILIFAT
                ON FAT.CDFILIALFATURA = FILIFAT.CDFILIAL
               AND FAT.NRORG          = FILIFAT.NRORG
        INNER JOIN PARCNEGOCIO PARCFAT
                ON FAT.NRPARCFATURA = PARCFAT.NRPARCNEGOCIO
               AND FAT.NRORG        = PARCFAT.NRORG
         LEFT JOIN (SELECT APURFAT.NRFATURACONT, LISTAGG(NF.NRLANCTONF, ', ') WITHIN GROUP( ORDER BY NF.NRLANCTONF ) AS NRLANCTONF,
                           NF.CDFILIAL, LISTAGG(NF.NRNOTAFISC, ', ') WITHIN GROUP( ORDER BY NF.NRNOTAFISC ) AS NRNOTAFISC,
                           NF.DTENTRSAID, APURFAT.NRORG, NF.VRNOTAFISC
                      FROM FCT_RELACAPURACAOFATURA APURFAT
                INNER JOIN FCT_APURACAO APU
                        ON APURFAT.NRAPURACAO = APU.NRAPURACAO
                       AND APURFAT.NRORG      = APU.NRORG
                 LEFT JOIN NOTAFISCAL NF
                        ON APU.NRLANCTONF = NF.NRLANCTONF
                       AND APU.CDFILIAL   = NF.CDFILIAL
                  GROUP BY NF.CDFILIAL, APURFAT.NRFATURACONT, NF.DTENTRSAID, APURFAT.NRORG, NF.VRNOTAFISC) NF
                ON FAT.NRFATURACONT = NF.NRFATURACONT
               AND FAT.NRORG = NF.NRORG
         LEFT JOIN CONTARECEBER CONTREC
                ON CONTREC.NRLANCTONF   = NF.NRLANCTONF
               AND CONTREC.CDFILIAL     = NF.CDFILIAL
               AND CONTREC.NRORG        = NF.NRORG
         LEFT JOIN FILIAL FILINF
                ON NF.CDFILIAL = FILINF.CDFILIAL
             WHERE FAT.NRORG        = :NRORG
               AND FAT.NRPARCFATURA = :NRPARCNEGOCIO
               AND CONT.IDATIVO     = 'S'
               AND FAT.IDSITUACAO IN ('3')

               $dtinicompetFilter
               $dtfincompetFilter

    UNION ALL

    SELECT DISTINCT DECODE(AGRUPCONT.NRMEDICAOFATURA, NULL, 'P', DECODE(AGRUPCONT.IDPARCAGRUP, 'S', 'A', 'M')) AS TIPO, AGRUPCONT.IDPARCAGRUP, TO_CHAR(DSJUSTIFICATIVA) AS DSJUSTIFICATIVA,
                    DECODE(AGRUPCONT.IDPARCAGRUP, 'N', CONT.NRCONTRATOFCT, AGRUPA.NMAGRUPAMENTO) AS NRCONTRATOFCT,
                    CASE AGRUPCONT.IDPARCAGRUP WHEN 'N'
                         THEN TO_CHAR(CONT.NRSEQCONTRATO)
                         ELSE (SELECT LISTAGG(NRSEQCONTRATO, '_') WITHIN GROUP( ORDER BY NRSEQCONTRATO)
                                 FROM FCT_RELACAGRUPCONTFAT
                                WHERE NRFATURACONT = FAT.NRFATURACONT)
                     END AS NRSEQCONTRATO,
                   DECODE(AGRUPCONT.NRMEDICAOFATURA, NULL, 'P'||FAT.NRFATURACONT, DECODE(AGRUPCONT.IDPARCAGRUP, 'S', 'A'||FAT.NRFATURACONT, 'M'||AGRUPCONT.NRMEDICAOFATURA)) AS NRFATURACONT, FAT.NRGRUPOFATURA, FAT.CDFILIALFATURA, FILIFAT.NMFILIAL AS NMFILIALFATURA,
                   FAT.NRPARCFATURA, PARCFAT.NMPRINCIPALPARC AS NMPARCFATURA, FAT.IDTPFATURA,
                   'PENDENTE' AS IDSITUACAO,
                   FAT.DTINICOMPET, FAT.DTFINCOMPET,
                   FAT.DTLIMITEAPU, NULL AS DTVENCIMENTO, FAT.NRDIASVENCIMENTO, FAT.QTDIASFATUVENC, FAT.VRVENCIMENTO,
                   FAT.VRFATURADO, FAT.VRFALTAFATURAR, FAT.IDFORMAFATURA, FAT.IDALTUSUARIO, FAT.NRAPURACAO, NF.NRLANCTONF,
                   NF.CDFILIAL AS CDFILIALNF, FILINF.NMFILIAL AS NMFILIALNF, NF.NRNOTAFISC, NF.DTENTRSAID, FAT.IDATIVO,
                   FAT.NRORG, FAT.DTINCLUSAO, FAT.NRORGINCLUSAO, FAT.CDOPERINCLUSAO, FAT.DTULTATU, FAT.NRORGULTATU,
                   FAT.CDOPERULTATU,
                   DECODE(AGRUPCONT.IDPARCAGRUP, 'N', CONT.DSREFERENCIACONT, AGRUPA.DSOBSAGRUPAMENTO) DSREFERENCIACONT,
                   NF.VRNOTAFISC,
                   NULL AS VRATUAREC
              FROM FCT_FATURACONT FAT
        INNER JOIN FCT_RELACAGRUPCONTFAT AGRUPCONT
                ON FAT.NRFATURACONT = AGRUPCONT.NRFATURACONT
               AND FAT.NRORG        = AGRUPCONT.NRORG
         LEFT JOIN FCT_CONTRATO CONT
                ON AGRUPCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
               AND AGRUPCONT.NRORG         = CONT.NRORG
         LEFT JOIN FCT_RELACAGRUPAMENTOCONT RELAGRUPCONT
                ON RELAGRUPCONT.NRSEQCONTRATO = CONT.NRSEQCONTRATO
               AND RELAGRUPCONT.NRORG         = CONT.NRORG
         LEFT JOIN FCT_AGRUPAMENTO AGRUPA
                ON AGRUPA.NRAGRUPAMENTO = RELAGRUPCONT.NRAGRUPAMENTO
               AND AGRUPA.NRORG         = RELAGRUPCONT.NRORG
        INNER JOIN FILIAL FILIFAT
                ON FAT.CDFILIALFATURA = FILIFAT.CDFILIAL
               AND FAT.NRORG          = FILIFAT.NRORG
        INNER JOIN PARCNEGOCIO PARCFAT
                ON FAT.NRPARCFATURA = PARCFAT.NRPARCNEGOCIO
               AND FAT.NRORG = PARCFAT.NRORG
         LEFT JOIN (SELECT APURFAT.NRFATURACONT, LISTAGG(NF.NRLANCTONF, ', ') WITHIN GROUP( ORDER BY NF.NRLANCTONF ) AS NRLANCTONF,
                           NF.CDFILIAL, LISTAGG(NF.NRNOTAFISC, ', ') WITHIN GROUP( ORDER BY NF.NRNOTAFISC ) AS NRNOTAFISC,
                           NF.DTENTRSAID, APURFAT.NRORG, NF.VRNOTAFISC
                      FROM FCT_RELACAPURACAOFATURA APURFAT
                INNER JOIN FCT_APURACAO APU
                        ON APURFAT.NRAPURACAO = APU.NRAPURACAO
                       AND APURFAT.NRORG      = APU.NRORG
                 LEFT JOIN NOTAFISCAL NF
                        ON APU.NRLANCTONF = NF.NRLANCTONF
                       AND APU.CDFILIAL   = NF.CDFILIAL
                 GROUP  BY NF.CDFILIAL, APURFAT.NRFATURACONT, NF.DTENTRSAID, APURFAT.NRORG, NF.VRNOTAFISC) NF
                ON FAT.NRFATURACONT = NF.NRFATURACONT
               AND FAT.NRORG = NF.NRORG
         LEFT JOIN FILIAL FILINF
                ON NF.CDFILIAL = FILINF.CDFILIAL
             WHERE FAT.NRORG        = :NRORG
               AND FAT.NRPARCFATURA = :NRPARCNEGOCIO
               AND CONT.IDATIVO     = 'S'
               AND FAT.IDSITUACAO IN ('1', '2', '6')

    UNION ALL

        SELECT 'M' AS TIPO, NULL AS IDPARCAGRUP, NULL AS DSJUSTIFICATIVA, MED.NRCONTRATOFCT, TO_CHAR(MED.NRSEQCONTRATO) AS NRSEQCONTRATO,
             'M'||MED.NRMEDICAOFATURA AS NRFATURACONT, MED.NRGRUPOFATURA, MED.CDFILIALFATURA,  MED.NMFILIALFATURA,
             MED.NRPARCFATURA, MED.NMPARCFATURA, MED.IDTPFATURA, 'ESTIMADO' AS IDSITUACAO,
             MED.DTINICOMPET,MED.DTFINCOMPET,
             MED.DTLIMITEAPU, NULL AS DTVENCIMENTO, MED.NRDIASVENCIMENTO, MED.QTDIASFATUVENC,MED.PRECOMEDICAO AS VRVENCIMENTO,
             0 AS VRFATURADO, MED.PRECOMEDICAO AS VRFALTAFATURAR, NULL AS IDFORMAFATURA, NULL AS IDALTUSUARIO, NULL AS NRAPURACAO, NULL AS NRLANCTONF,
             NULL AS CDFILIALNF, NULL AS NMFILIALNF, NULL AS NRNOTAFISC, NULL AS DTENTRSAID, MED.IDATIVO,
             MED.NRORG, MED.DTINCLUSAO, MED.NRORGINCLUSAO, MED.CDOPERINCLUSAO, MED.DTULTATU, MED.NRORGULTATU,
             MED.CDOPERULTATU,  MED.DSREFERENCIACONT,
             NULL AS VRNOTAFISC,
             NULL AS VRATUAREC
         FROM TABLE(FCT_BUSCA_PRECOMEDICAO(:NRPARCNEGOCIO, :NRORG)) MED
         INNER JOIN FCT_CONTRATO CONT
           ON MED.NRSEQCONTRATO = CONT.NRSEQCONTRATO
          AND MED.NRORG = CONT.NRORG
         WHERE CONT.IDATIVO = 'S'

         $dtinicompetFilterMed
         $dtfincompetFilterMed
)

WHERE 1 = 1
    $filter
    $orderString
SQL;

        $params = array(
            "NRORG" => $nrorg,
            "NRPARCNEGOCIO" => $nrparcnegocio
        );

        $query = $this->getPaginatedQuery($query, $limit, $offset);

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    private function getPaginatedQuery($query, $limit, $offset) {
        if ($limit > 0) {
            $max = $offset + $limit;
            $column = '*';
            if ($offset > 0) {
                $min = $offset + 1;
                $query = 'SELECT * FROM (SELECT a.' . $column . ', rownum AS doctrine_rownum FROM (' .
                    $query .
                    ') a WHERE rownum <= ' . $max . ') WHERE doctrine_rownum >= ' . $min;
            } else {
                $query = 'SELECT a.' . $column . ' FROM (' . $query . ') a WHERE ROWNUM <= ' . $max;
            }
        }

        return $query;
    }


}
