<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\DateUtil;
use HCM\Util\FPA;
use HCM\Util\Repositories;

class FpaGozoferias extends \Doctrine\ORM\EntityRepository {
    
    public function retornaItem($nrorg, $nrvinculom) {
        
        $fpaGozoFerias = Repositories::FPA_GOZOFERIAS;
        $fpaFerias = Repositories::FPA_FERIAS;
        
        $sql = <<<SQL
SELECT gf
  FROM $fpaGozoFerias gf
WHERE gf.nrorg = :p_nrorg
  AND gf.nrferias IN (
				    SELECT f.nrferias FROM $fpaFerias f
				    WHERE f.nrorg = gf.nrorg
				    AND f.nrvinculom = :p_nrvinculom)
				ORDER BY gf.dtinigozoferias DESC
SQL;
        $params = array(
            'p_nrorg' => $nrorg,
            'p_nrvinculom' => $nrvinculom
        );
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }
    
    public function retornaGozosFeriasEntreDatas($nrorg, $nrvinculom, $dtIni, $dtFim) {
        
        $fpaGozoFerias = Repositories::FPA_GOZOFERIAS;
        $fpaFerias = Repositories::FPA_FERIAS;
        
        $sql = <<<SQL
SELECT gf
  FROM $fpaGozoFerias gf
WHERE gf.nrorg = :p_nrorg
  AND gf.nrferias IN (
				    SELECT f.nrferias FROM $fpaFerias f
				    WHERE f.nrorg = gf.nrorg
				    AND f.nrvinculom = :p_nrvinculom)
  AND (gf.dtinigozoferias between :p_dtini and :p_dtfim or
        gf.dtfimgozoferias between :p_dtini and :p_dtfim  )
				ORDER BY gf.dtinigozoferias DESC
SQL;
        $params = array(
            'p_nrorg' => $nrorg,
            'p_nrvinculom' => $nrvinculom,
            'p_dtini' => $dtIni->format('d/m/Y'),
            'p_dtfim' => $dtFim->format('d/m/Y')
        );
        
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }
    
    public function deletaGozoFerias($nr_gozoferias, $nr_org, $nr_ferias){
       
        $params = array('nrgozoferias'=> $nr_gozoferias, 'nrorg'=> $nr_org, 'nrferias' => $nr_ferias);
        $fpaGozoFerias = Repositories::FPA_GOZOFERIAS;
            
$sql = <<<SQL
    DELETE FROM $fpaGozoFerias g WHERE g.nrgozoferias = :nrgozoferias AND g.nrorg = :nrorg AND g.nrferias = :nrferias
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
    }
    
    
}