<?php
namespace Teknisa\Model\Teknisa\Repositories;
use OrganizationsManagement\Util\Utilities;


class OmIntegracoes extends \Doctrine\ORM\EntityRepository {
    
    public function getSMIntegrationUrl($nrorg)
    {
        $query = <<<SQL
		  SELECT ID, DSURLSM
		    FROM OM_INTEGRACOES
		   WHERE NRORG = :nrorg
SQL;
         $param = array(
            'nrorg' => $nrorg
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $param);
    }

    public function findSMParameters($nrorg, $filterString = '')
    {
        $query = <<<SQL
    SELECT *
      FROM (SELECT
                PARAM.NRPARAMETROGERAL,
                PARAM.IDINTEGRACAOOM,
                PARAM.URLINTEGRACAOOM,
                PARAM.IDCONVERSAOPROSPECT,
                PARAM.IDCONVCLIENTE,
                PARAM.IDINTEGRACAOCRM,
                PARAM.URLINTEGRACAOCRM,
                PARAM.NRORCAMODELOCUST,
                MODPRO.NMORCAMENTOMODELO AS NMORCAMODELOCUST,
                PARAM.CDPRECBASESERVCUST,
                PRECO.DSPRECBASESERV AS DSPRECBASESERVCUST
            FROM FCT_PARAMETROGERAL PARAM
            LEFT JOIN FCT_ORCAMENTOMODELO MODPRO ON PARAM.NRORCAMODELOCUST = MODPRO.NRORCAMENTOMODELO
                                                AND PARAM.NRORG = MODPRO.NRORG
            LEFT JOIN FCT_PRECBASESERV PRECO ON PARAM.CDPRECBASESERVCUST = PRECO.CDPRECBASESERV
                                            AND PARAM.NRORG = PRECO.NRORG
            WHERE PARAM.NRORG = :NRORG
         )
      WHERE 1=1
         $filterString
SQL;
        $params = array(
            "NRORG" => $nrorg
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);

    }
    public function findBudgetModel($filterString = '')
    {
        $query = <<<SQL
       SELECT *
         FROM FCT_ORCAMENTOMODELO
         WHERE 1=1 $filterString
SQL;
        return $this->getEntityManager()->getConnection()->fetchAll($query);

    }
    public function priceCustomization($filterString = '')
    {
        $query = <<<SQL
       SELECT *
         FROM FCT_PRECBASESERV
         WHERE 1=1 $filterString
SQL;
        return $this->getEntityManager()->getConnection()->fetchAll($query);

    }

    public function findServicoOrca($params, $filterString = '', $limit, $offset)
    {
        $query = <<<SQL
        SELECT *
          FROM (SELECT CDSERVORCA, NMSERVORCA, DSSERVORCA, IDLICENUSOMANUT, IDATIVO
                  FROM FCT_SERVICOORCA
                 WHERE NRORG = :nrorg)
         WHERE 1 = 1
            $filterString
SQL;

        $query = Utilities::getPaginatedQuery($query, $limit, $offset);
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    public function findProductLineServOrca($params)
    {
        $query = <<<SQL
        SELECT LU.CDSERVORCA AS CDSERVORCA_LU, LU.NMSERVORCA AS USE_LICENSE,
               MA.CDSERVORCA AS CDSERVORCA_MA, MA.NMSERVORCA AS MAINTENANCE,
               QT.CDTPMEDIDASERV AS CDTPMEDIDASERV_QT, QT.DSTPMEDIDASERV AS MIN_QUANTITY
          FROM (SELECT CDSERVORCA, NMSERVORCA
                  FROM FCT_SERVICOORCA
                 WHERE IDLICENUSOMANUT = 'L'
                   AND IDATIVO = 'S'
                   AND NRORG = :nrorg) LU,
               (SELECT CDSERVORCA, NMSERVORCA
                  FROM FCT_SERVICOORCA
                 WHERE IDLICENUSOMANUT = 'M'
                   AND IDATIVO = 'S'
                   AND NRORG = :nrorg) MA,
               (SELECT CDTPMEDIDASERV, DSTPMEDIDASERV
                  FROM FCT_TIPOMEDIDASERV
                 WHERE IDQTMINIMA = 'S'
                   AND IDATIVO = 'S'
                   AND NRORG = :nrorg) QT
SQL;

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }

    
}