function AclAccessProfileController(ScreenService, templateManager, localStorageEngine, ZhuAclController,
                                    AclMessages, AccessProfileService, ACLUtilities, ZHPromise, ZhuAclExportRulesController, General){

	var self = this;
	var ALE_FILL_REQ_FIELD = AclMessages.ALE_FILL_REQ_FIELD;
	var ERR_DEL_PROFILE = AclMessages.ERR_DEL_PROFILE;
	var ERR_SAV_PROFILE = AclMessages.ERR_SAV_PROFILE;
	var ERR_SAV_PROFILE_OPERATORS = AclMessages.ERR_SAV_PROFILE_OPERATORS;
	var CON_DEL_PROFILE = AclMessages.CON_DEL_PROFILE;
	var CON_DEL_PROFILE_OPERATORS = AclMessages.CON_DEL_PROFILE_OPERATORS;
	var CON_DEL_PROFILE_OPERATORS_PERFILFILIAL = AclMessages.CON_DEL_PROFILE_OPERATORS_PERFILFILIAL;
	var SUC_DEL_OPERATOR = AclMessages.SUC_DEL_OPERATOR;
	var CON_CHEN_ACCESS_PROFILE = AclMessages.CON_CHEN_ACCESS_PROFILE;

	self.profileWidgetAfterMoveRow = function() {
		return self.setChildFilters(self.getWidgetProfile());
	};

	self.profileActionEventNew = function() {
		return self.addProfile(self.getWidgetProfile());
	};

	self.profileActionEventEnableAccessControll = function() {
		return self.enableAccessControll();
	};
	
	self.profileActionEventChangeAccessControll = function() {
		return self.changeTypeAccessControl();
	};
	
	self.profileActionEventHabParametAccessControlBranch = function() {
		return self.habParamAccessControl();
	};
	
	
	self.profileActionEventChangeAccessControl = function() {
		return self.openPopupchangeAccessProfile();
	};

	self.profileActionEventBack = function() {
		return self.masterDetailBackToList(self.getWidgetProfile());
	};

	self.profileActionEventCancel = function() {
		return self.profileRollback(self.getWidgetProfile());
	};

	self.profileActionEventEdit = function() {
		return self.editProfile(self.getWidgetProfile());
	};

	self.profileActionEventDelete = function() {
		return self.deleteProfileConfirmation(self.getWidgetProfile());
	};

	self.profileActionEventExportRules = function() {
		var profileWidget = self.getWidgetProfile();
		ZhuAclExportRulesController.profileActionEventExportRules(profileWidget.currentRow.NRPERFILACESSO);
	};

	self.profileActionEventSave = function() {
		return self.saveProfile(self.getWidgetProfile());
	};

	self.operatorsWidgetOnEnter = function() {
			self.getWidgetOperators().getField('DTVALIDADE').showOnList = getLocalVar('IDUTLPERFILFILIAL') == 'N';
			self.getWidgetOperators().getField('DTVALIDADE').isVisible = getLocalVar('IDUTLPERFILFILIAL') == 'N';
			self.getWidgetRelatedBranches().isVisible = getLocalVar('IDUTLPERFILFILIAL') != 'N';
			return self.getWidgetOperators().reload();
	};
	
	self.controlProfileWidgetOnEnter = function() {
		return self.getWidgetControlProfile().reload();
	};

	self.operatorsActionEventNew = function() {
		return self.loadOperators(self.getWidgetOperators());
	};
	
	self.controlProfileActionEventNew = function() {
		return self.loadControlProfile(self.getWidgetControlProfile());
	};

	self.operatorsActionEventBack = function() {
		return self.masterDetailBackToList(self.getWidgetProfile());
	};
	
	self.relatedBranchesActionEventBack = function() {
		return self.masterDetailBackToList(self.getWidgetRelatedBranches());
	};
	
	self.controlProfileActionEventBack = function() {
		return self.masterDetailBackToList(self.getWidgetProfile());
	};

	self.addOperatorActionEventAdd = function(currentWidget) {
		return self.addPerfAcessParc(self.getWidgetAddOperator(), currentWidget);
	};
	
	self.addControlProfileActionEventAdd = function(currentWidget) {
		return self.addControlProfile(self.getWidgetAddControlProfile(), currentWidget);
	};

	self.addOperatorActionEventCancel = function(currentWidget) {
		if(currentWidget && currentWidget.unSelectAll){
			currentWidget.unSelectAll();
		}
		self.getWidgetTabbedChildrenAddOperators().currentRow.DTVALIDADE = '';
		ScreenService.closeSwipe();
	};

	self.getContainerAccessProfile = function(){
		return templateManager.container;
	};

	self.getWidgetProfile = function() {
		return templateManager.container.getWidget('profile');
	};

	self.getWidgetOperators = function() {
		return templateManager.container.getWidget('operators');
	};
	
	self.getWidgetRelatedBranches = function() {
		return templateManager.container.getWidget('RELATED_BRANCHES');
	};
	
	self.getWidgetControlProfile = function() {
		return templateManager.container.getWidget('controlProfile');
	};

	self.getWidgetTabbedChildrenAddOperators = function() {
		return templateManager.container.getWidget('TABBED_CHILDREN_ADD_OPERATOR');
	};

	self.getWidgetAddOperator = function() {
		return templateManager.container.getWidget('addOperator');
	};
	
	self.getWidgetAddControlProfile = function() {
		return templateManager.container.getWidget('TABBED_CHILDREN_ADD_PROFILE');
	};

	self.getWidgetElements = function() {
		return templateManager.container.getWidget('elements');
	};
	
	self.getWidgetChangeaccessProfile = function() {
		return templateManager.container.getWidget('changeAccessControl');
	};

	self.getActionViewFromElements = function() {
		return self.getWidgetElements().getAction('view');
	};

	self.getActionEnableAccessProfile = function() {
		return self.getWidgetProfile().getAction('enableAccessProfile');
	};
	
	self.getActionChangeAccessProfile = function() {
		return self.getWidgetProfile().getAction('changeAccessControl');
	};

	self.getActionHabParamProfile = function() {
		return self.getWidgetProfile().getAction('habParamProfile');
	};

	self.getActionEditFromElements = function() {
		return self.getWidgetElements().getAction('edit');
	};

	self.setWidgetsVisibility = function (arrayWidgets, visibility) {
		arrayWidgets.forEach(
			function (element) {
				var conditionOperatorsVisibility = (getLocalVar('IDUTLPERFILFILIAL') != 'N' && element.isVisibleInPerfAccessFili !== false);
				var conditionControlProfileVisibility =  (getLocalVar('IDUTLPERFILFILIAL') == 'N' && element.isVisibleInPerfAccessFili !== true);
				if( conditionOperatorsVisibility || conditionControlProfileVisibility){
					element.isVisible = visibility;
				}
			}
		);
	};

	self.addProfile = function(accessProfileWidget) {
		self.setWidgetsVisibility(accessProfileWidget.widgets, false);
		accessProfileWidget.newRow();
	};

	self.editProfile = function (accessProfileWidget) {
		self.setWidgetsVisibility(accessProfileWidget.widgets, false);
		accessProfileWidget.backupRow = Util.clone(accessProfileWidget.currentRow);
		accessProfileWidget.edit();
	};

	self.profileRollback = function (accessProfileWidget) {
		if (accessProfileWidget.isNewRow()) {
			if (accessProfileWidget.dataSource.data.indexOf(accessProfileWidget.currentRow) !== -1) {
				accessProfileWidget.dataSource.data.pop();
			}
			self.masterDetailBackToList(accessProfileWidget);
		}
		else {
			Util.extend(accessProfileWidget.currentRow, accessProfileWidget.backupRow);
			accessProfileWidget.view();
		}
		self.setWidgetsVisibility(accessProfileWidget.widgets, true);
	};

	self.masterDetailBackToList = function(accessProfileWidget) {
		ScreenService.closeSwipe().then(function() {
			accessProfileWidget.list();
			accessProfileWidget.activate();
		});
	};

	self.deleteProfileConfirmation = function(){
		ScreenService.confirmMessage(
			CON_DEL_PROFILE,
			'ALERT',
			removeProfile
		);
	};

	var removeProfile = function(){
		var accessProfileWidget = self.getWidgetProfile();
		accessProfileWidget.currentRow.__is_new = false;
		accessProfileWidget.removeRow().then(function(){
			ScreenService.closeSwipe();
		}).catch(function (error) {
			ScreenService.errorNotification(ERR_DEL_PROFILE + error.error);
		});
	};

	self.setChildFilters = function (accessProfileWidget) {
		var operatorsWidget = self.getWidgetOperators();
		var controlProfileWidget = self.getWidgetControlProfile();
		var groupId = accessProfileWidget.currentRow.NRPERFILACESSO;
		operatorsWidget.dataSourceFilter[0].value = groupId;
        operatorsWidget.reload();
        if(getLocalVar('IDUTLPERFILFILIAL') != 'N'){
        	controlProfileWidget.dataSourceFilter[0].value = groupId;
        	controlProfileWidget.reload();
        }
        ZhuAclController.setElementsListFilter(accessProfileWidget.container, groupId);
		accessProfileWidget.activate();
	};

	self.saveProfile = function(accessProfileWidget) {
		if(accessProfileWidget.isValid()) {
			accessProfileWidget.currentRow.SHOW_FULL_OPERATOR = (window.showFullOperatorWindow || false);
			accessProfileWidget.saveRow().then(
				afterSave,
				function(response){
					ScreenService.errorNotification(ERR_SAV_PROFILE + response.data.error);
				}
			);
		}
		else{
			ScreenService.showMessage(ALE_FILL_REQ_FIELD, "", "exclamation");
		}
	};

	function afterSave(response) {
		var accessProfileWidget = self.getWidgetProfile();
		var responseAccessProfile = getLocalVar('IDUTLPERFILFILIAL') == 'S' ? response.dataset.accessProfileWithIdBlockFilial[0] : response.dataset.accessProfile[0];
		var id = responseAccessProfile.NRPERFILACESSO;
		var nrOrg = responseAccessProfile.NRORG;
		var operator = response.dataset.accessProfileRowsDefaultValues[0].CDOPERINCLUSAO;
		var createDate = response.dataset.accessProfileRowsDefaultValues[0].DTINCLUSAO;
		self.setWidgetsVisibility(accessProfileWidget.widgets, true);
		accessProfileWidget.currentRow.NRPERFILACESSO = id;
		accessProfileWidget.currentRow.NRORG = nrOrg;
		accessProfileWidget.currentRow.NRORGINCLUSAO = nrOrg;
		accessProfileWidget.currentRow.CDOPERINCLUSAO = operator;
		accessProfileWidget.currentRow.DTINCLUSAO = createDate;
		accessProfileWidget.currentRow.__is_new = false;
		accessProfileWidget.currentRow.changed = false;
		accessProfileWidget.view();
		self.setChildFilters(accessProfileWidget);
	}

	self.loadOperators = function(operatorsWidget) {
		var addOperatorTabbedWidget = operatorsWidget.container.getWidget("TABBED_ADD_OPERATOR");
		var tabbedChildrenAddOpertors = self.getWidgetTabbedChildrenAddOperators();
		var addOperatorWidget = operatorsWidget.container.getWidget("addOperator");
		var nrParcNegocio = [];
		var addOperatorsTabbedChildrenWidget = self.getWidgetTabbedChildrenAddOperators();
		addOperatorsTabbedChildrenWidget.currentRow.CDFILIAL = '';
		addOperatorsTabbedChildrenWidget.currentRow.NMFILIAL = '';
		tabbedChildrenAddOpertors.getField('CDFILIAL').isVisible = getLocalVar('IDUTLPERFILFILIAL') != 'N';
		tabbedChildrenAddOpertors.getField('DTVALIDADE').isVisible = getLocalVar('IDUTLPERFILFILIAL') == 'N';
		operatorsWidget.dataSource.data.forEach(function(data){
			nrParcNegocio.push(data.NRPARCNEGOCIO);
		});

		if(nrParcNegocio.length > 0 && getLocalVar('IDUTLPERFILFILIAL') == 'N') {
			addOperatorWidget.dataSourceFilter = [{
				"name": "NRPARCNEGOCIO",
				"operator": "NOT IN",
				"value": nrParcNegocio
			}];
		}
		addOperatorWidget.reload();
		ScreenService.openSwipe(addOperatorTabbedWidget).then(function(){
			addOperatorTabbedWidget.edit();
			addOperatorWidget.activate();
		});
	};
	
	self.loadControlProfile = function(ControlProfileWidget) {
		var addOperatorTabbedWidget = ControlProfileWidget.container.getWidget("TABBED_ADD_PROFILE_CONTROLLED");
		var addOperatorTabbedChildrenWidget = ControlProfileWidget.container.getWidget("TABBED_CHILDREN_ADD_PROFILE");
		
		addOperatorTabbedChildrenWidget.reload();
		ScreenService.openSwipe(addOperatorTabbedWidget).then(function(){
			addOperatorTabbedWidget.edit();
			addOperatorTabbedChildrenWidget.activate();
		});
	};

	self.addPerfAcessParc = function (widget, currentWidget) {
		var profileWidget = self.getWidgetProfile();
		var operators     = widget.getCheckedRows();
		var addOperatorsTabbedChildrenWidget = self.getWidgetTabbedChildrenAddOperators();
		
		if(addOperatorsTabbedChildrenWidget.isValid()){
	        operators = operators.map(function (element) {
				element.CDTIPOINSCRICAO = getInscriptionType(element.NRINSCRICAOPARC);
	            element.NRPERFILACESSO = profileWidget.currentRow.NRPERFILACESSO;
	            element.DTVALIDADE = addOperatorsTabbedChildrenWidget.currentRow.DTVALIDADE || null;
	            element.CDFILIAL = self.getWidgetTabbedChildrenAddOperators().currentRow.CDFILIAL;
	            element.SHOW_FULL_OPERATOR = (window.showFullOperatorWindow || false);
	            element.__is_new = true;
	            element.changed = true;
	            return element;
	        });
        
			AccessProfileService.savePerfAccessParc(operators).then(
				finishAddOperators,
				function () {
					ScreenService.errorNotification(ERR_SAV_PROFILE_OPERATORS);
				}
			);
			if(currentWidget && currentWidget.unSelectAll){
				currentWidget.unSelectAll();
			}
		}
	};
	
	self.addControlProfile = function (widget, currentWidget) {
		var profile = widget.getCheckedRows();

        profile = profile.map(function (element) {
            element.__is_new = true;
            element.changed = true;
            return element;
        });

		AccessProfileService.saveControlProfile(profile).then(
			finishAddProfiles,
			function () {
				ScreenService.errorNotification(ERR_SAV_PROFILE_OPERATORS);
			}
		);

		if(currentWidget && currentWidget.unSelectAll){
			currentWidget.unSelectAll();
		}
	};

	var finishAddOperators = function() {
		var operatorsWidget = self.getWidgetOperators();
		delete(self.getWidgetTabbedChildrenAddOperators().currentRow.DTVALIDADE);
		operatorsWidget.reload();
		ScreenService.closeSwipe();
		operatorsWidget.list();
		operatorsWidget.activate();
	};
	
	var finishAddProfiles = function() {
		var controlProfileWidget = self.getWidgetControlProfile();
		controlProfileWidget.reload();
		ScreenService.closeSwipe();
		controlProfileWidget.list();
		controlProfileWidget.activate();
	};

	var getInscriptionType = function (inscription) {
		if (inscription) {
			if (inscription.length == 11) {
				return "CPF";
			} else if (inscription.length == 14) {
				return "CNPJ";
			}
		} else {
			return "LIVRE";
		}
	};

	self.getProductId = function() {
		localStorageEngine.getLocalVar("productIdLoginUrl");
	};

    this.accessProfileContainerAfterinit = function() {
        ZhuAclController.insertElementsListWidget(templateManager.container, self.getWidgetProfile(), window.aclExtraElementsFile);

        var loginPromise = localStorageEngine.getLocalVar('loginPromise') || ZHPromise.when();
        ScreenService.showLoader();
        loginPromise.then(function() {
            AccessProfileService.validateNovoCodigo();

            ScreenService.hideLoader();
            findAccessControllUtilization();

			ACLUtilities.getTypeAccessProfile().then(function(response) {
				var typeAccessProfile = 'N';
				if(response && response.dataset) {
					typeAccessProfile = response.dataset.findTypeAccessProfile[0];
				}
				localStorageEngine.setLocalVar('IDUTLPERFILFILIAL', window.showFullOperatorWindow ? typeAccessProfile : 'N');
				self.getWidgetControlProfile().isVisible =  window.showFullOperatorWindow && typeAccessProfile != 'N';
			});
        }).catch(ScreenService.hideLoader);
    };

    this.profileWidgetOnEnter = function(){
        var loginPromise = localStorageEngine.getLocalVar('loginPromise') || ZHPromise.when();
        ScreenService.showLoader();
		loginPromise.then(function() {
			ScreenService.hideLoader();
			var widget = self.getWidgetProfile();
			localStorageEngine.setLocalVar('IDUTLPERFILFILIAL', window.showFullOperatorWindow ? getLocalVar('IDUTLPERFILFILIAL') : 'N');
			changeLabelChangeAccessProfile(getLocalVar('IDUTLPERFILFILIAL'));
			widget.getField('IDBLOCKFILIAL').isVisible = window.showFullOperatorWindow && getLocalVar('IDUTLPERFILFILIAL') != 'N';
			widget.currentRow = { IDATIVO: "S" };
			ACLUtilities.applyDefaultFilterOnEnter(widget);
		}).catch(ScreenService.hideLoader);
    };

    this.profileFilterAfterApply = function() {
        ACLUtilities.setFilterInit(self.getWidgetProfile());
    };

    this.enableAccessControll = function() {
    	ScreenService.confirmMessage(
			CON_CHEN_ACCESS_PROFILE,
			'question',
			changeAccessControll
		);
	};
	
	this.openPopupchangeAccessProfile = function(){
		ScreenService.openPopup(this.getWidgetChangeaccessProfile());
	};

    var changeAccessControll = function(){
		var row = {};
		row.IDUTCTRLACESWEB = localStorageEngine.getLocalVar("idutctrlacesweb");
		row.changed = true;
        AccessProfileService.validateActivation().then(function(response){
            var result = response.dataset.validateActivation[0].TOTAL;
            if(result != 0 || row.IDUTCTRLACESWEB == 'S') {
                AccessProfileService.changeAccessProfile(row).then(function(response){
                    var idutctrlacesweb = response.dataset.changeAccessProfile[0].idutctrlacesweb;
                    var msg = (idutctrlacesweb == 'S') ? AclMessages.SUC_ACCESS_PROFILE_ACTIVATED : AclMessages.SUC_ACCESS_PROFILE_DISABLED ;
                    changeLabelEnableAccessProfile(idutctrlacesweb);
                    localStorageEngine.setLocalVar("idutctrlacesweb", idutctrlacesweb);
                    ScreenService.successNotification(msg);
                });
            } else {
                ScreenService.showMessage(AclMessages.ALE_NO_PERMISSION_TO_ACTIVATE_ACCESS_CONTROL);
            }
        });
    };



    var findAccessControllUtilization = function(){
    	AccessProfileService.findAccessControllUtilization().then(function(response){
    		var idutctrlacesweb;
    		var AccessControllUtilization = response.dataset.findAccessControllUtilization;
    		if (AccessControllUtilization && AccessControllUtilization.length > 0) {
        		idutctrlacesweb = AccessControllUtilization[0].IDUTCTRLACESWEB;
    		} else {
    			idutctrlacesweb = "N";
    		}
        	localStorageEngine.setLocalVar("idutctrlacesweb", idutctrlacesweb);
        	changeLabelEnableAccessProfile(idutctrlacesweb);
        });
    };

    var changeLabelEnableAccessProfile = function (idutctrlacesweb){
    	var actionEnableAccessProfile = self.getActionEnableAccessProfile();
    	var container = self.getContainerAccessProfile();
    	if (idutctrlacesweb == 'N') {
    		container.label = 'Access Profile (Access Control Disabled)';
    		actionEnableAccessProfile.label = 'Enable Access Control';
    	}else{
    		container.label = 'Access Profile';
    		actionEnableAccessProfile.label = 'Disable Access Control';
    	}
    };
    
    var changeLabelChangeAccessProfile = function (idutlperfilfilial){
    	var actionChangeAccessProfile = self.getActionChangeAccessProfile();
    	var actionHabParamProfile = self.getActionHabParamProfile();
    	actionChangeAccessProfile.isVisible = window.showFullOperatorWindow;
    	if (idutlperfilfilial == 'N') {
    		actionChangeAccessProfile.label = 'Use Access Control By Profile';
    		actionHabParamProfile.isVisible = window.showFullOperatorWindow;
    	} else if (idutlperfilfilial == 'P') {
    		actionChangeAccessProfile.label = 'Use Access Control By Profile';
    		actionHabParamProfile.isVisible = false;
    	} else {
    		actionChangeAccessProfile.label = 'Use Access Control By Operator';
    		actionHabParamProfile.isVisible = false;
    	}
    };

    this.operatorsActionEventDelete = function() {
    	var message = (getLocalVar('IDUTLPERFILFILIAL') != 'N' ? CON_DEL_PROFILE_OPERATORS_PERFILFILIAL : CON_DEL_PROFILE_OPERATORS);
    	ScreenService.confirmMessage(
			message,
			'ALERT',
			deleteOperator
		);
	};

	var deleteOperator = function(){
		var widget = self.getWidgetOperators();
		var row = {};
		if(getLocalVar('IDUTLPERFILFILIAL') != 'N'){
			row.CDOPERADOR = widget.currentRow.CDOPERADOR;
			row.NRPERFILACESSO = widget.currentRow.NRPERFILACESSO;
		}
		
		row.NRPERFACESSPARC = widget.currentRow.NRPERFACESSPARC;
		row.SHOW_FULL_OPERATOR = (window.showFullOperatorWindow || false);
		row.NRORG = widget.currentRow.NRORG;
		row.__is_new = false;
		row.changed = true;
		widget.dataSource.remove([row]).then(function(data) {
            ScreenService.closeSwipe();
            widget.reload();
            widget.list();
            ScreenService.successNotification(SUC_DEL_OPERATOR);
        }).then(null, function(message) {
            ScreenService.errorNotification(message);
        });
	};
	
	this.controlProfileActionEventDelete = function() {
    	ScreenService.confirmMessage(
		AclMessages.CON_DEL_PROFILE_CONTROL_PROFILE,
			'ALERT',
			deleteControlProfile
		);
	};
	
	this.relatedBranchActionEventDelete = function() {
    	ScreenService.confirmMessage(
		AclMessages.CON_DEL_RELATED_BRANCH_PROFILE,
			'ALERT',
			deleteRelatedBranch
		);
	};
	
	var deleteRelatedBranch = function(){
		var widget = self.getWidgetRelatedBranches();
		var row = {};
		row.NRPERFILACESSO = widget.currentRow.NRPERFILACESSO;
		row.CDOPERADOR = widget.currentRow.CDOPERADOR;
		row.CDFILIAL = widget.currentRow.CDFILIAL;
		row.NRORG = widget.currentRow.NRORG;
		row.__is_new = false;
		row.changed = true;
		widget.dataSource.remove([row]).then(function(data) {
            ScreenService.closeSwipe();
            widget.reload();
            widget.list();
            ScreenService.successNotification(AclMessages.SUC_DELETE_ACCESS_PROFILE);
        }).then(null, function(message) {
            ScreenService.errorNotification(message);
        });
	};
	
	var deleteControlProfile = function(){
		var widget = self.getWidgetControlProfile();
		var row = {};
		row.NRPERFILACESSO = widget.currentRow.NRPERFILACESSO;
		row.NRPERFACESSCONT = General.getFieldValue('NRPERFILACESSO', 'profile');
		row.NRORG = widget.currentRow.NRORG;
		row.__is_new = false;
		row.changed = true;
		widget.dataSource.remove([row]).then(function(data) {
            ScreenService.closeSwipe();
            widget.reload();
            widget.list();
            ScreenService.successNotification(AclMessages.SUC_DELETE_ACCESS_PROFILE);
        }).then(null, function(message) {
            ScreenService.errorNotification(message);
        });
	};
	
	this.editAccessControlOnEnter = function(args){
		var widget = args.owner;
		widget.currentRow.IDUTLPERFILFILIAL = getLocalVar('IDUTLPERFILFILIAL');
	};
	
	this.editAccessControlActionEventCancel = function(args){
        ScreenService.closePopup(this.getWidgetChangeaccessProfile());
    };
    
    this.editAccessControlActionEventSave = function(args){
    	var row = [];
    	row.id = 'N';
    	AccessProfileService.saveAccessControl(row).then(function(response){
    		ScreenService.closePopup();
    		ScreenService.successNotification(AclMessages.SUC_SAVE_CONTROL_PROFILE);
    	});
    };
    
	this.changeTypeAccessControl = function() {
    	ScreenService.confirmMessage(
			CON_CHEN_ACCESS_PROFILE,
			'question',
			changeTypeAccessControl
		);
	};
	
	this.habParamAccessControl = function() {
    	ScreenService.confirmMessage(
			CON_CHEN_ACCESS_PROFILE,
			'question',
			habParamAccessControl
		);
	};
	
	var changeTypeAccessControl = function(){
		var row = {};
			row.IDUTLPERFILFILIAL = localStorageEngine.getLocalVar("IDUTLPERFILFILIAL") == 'S' ? 'N' : 'S';
			row.changed = true;
    	AccessProfileService.changeAccessControl(row).then(function(response){
    		var IDUTLPERFILFILIAL = response.dataset.changeAccessControl[0].idutlperfilfilial;
    		changeLabelChangeAccessProfile(IDUTLPERFILFILIAL);
    		ScreenService.closePopup();
        	localStorageEngine.setLocalVar("IDUTLPERFILFILIAL", IDUTLPERFILFILIAL);
        	ScreenService.successNotification(AclMessages.SUC_CHANGE_ACCESS_PROFILE);
        	var containers = templateManager.containers;
            for (var key in containers) {
                if (!containers.hasOwnProperty(key)) continue;
                if(-1 != key.search('operator')){
                    delete containers[key];
                }
            }
            window.location.reload();
    	});
    };
    
    var habParamAccessControl = function(){
		var row = {};
			row.IDUTLPERFILFILIAL = 'P';
			row.changed = true;
    	AccessProfileService.changeAccessControl(row).then(function(response){
    		var IDUTLPERFILFILIAL = response.dataset.changeAccessControl[0].idutlperfilfilial;
    		changeLabelChangeAccessProfile(IDUTLPERFILFILIAL);
    		ScreenService.closePopup();
        	localStorageEngine.setLocalVar("IDUTLPERFILFILIAL", IDUTLPERFILFILIAL);
        	ScreenService.successNotification(AclMessages.SUC_CHANGE_ACCESS_PROFILE);
        	var containers = templateManager.containers;
            for (var key in containers) {
                if (!containers.hasOwnProperty(key)) continue;
                if(-1 != key.search('operator')){
                    delete containers[key];
                }
            }
            window.location.reload();
    	});
    };
    
}

Configuration(function(ContextRegister) {
	ContextRegister.register('AclAccessProfileController', AclAccessProfileController);
});
